#!/usr/bin/python
# -*- coding: utf-8 -*-

# "PyNengou"
# SYMBIAN_UID = 0xe7c5e258
# masa
# (c) 2013 masa
# web = "http://masaland.cocolog-nifty.com/"

__script__  = "PyNengou"
__version__ = "0.01(1)"
__copy__    = "masa"
__web__     = "http://masaland.cocolog-nifty.com/"

import sys, os
#sys.setdefaultencoding('utf-8')
if os.path.isdir('E:\\Python\\lib') :
    sys.path.insert(0, 'E:\\Python\\lib')

# モジュール読込
import re, time
import appuifw, e32, globalui

lock = e32.Ao_lock()

# マスタ情報
# 元号、スタート年マスター（この並び順に表示される）
NENGO_MASTER =  (("西暦",1), ("平成",1989),("昭和",1926),("大正",1912),("明治",1868))

# グローバル変数
#リストボックス関連（グローバル）
LISTBOX = ""


def check_input(input_data, cur_pos):
    check = True
    lower, upper = 0, 0
    if cur_pos == 0: # 入力は西暦
        if input_data > 2070 or input_data < 1868 :
            check = False
            lower, upper = 1868, 2070
    else: # 入力は明治～
        if input_data > 200 or input_data < 1 :
            check = False
            lower, upper = 1, 200
    return check, lower, upper


def make_list(e_year): # e_year 入力した年号に対応する西暦年
    global LISTBOX, NENGO_MASTER
    # 各元号の年を作成
    year_list = []
    year_list.append("%5s" % e_year)
    for i in range(1,len(NENGO_MASTER)):
        wk = e_year - NENGO_MASTER[i][1] + 1
        # その時には存在しない元号
        if wk < 1:
            wk = ("--")
        year_list.append(wk)

    # 表示する年号リストを作成
    list = []
    for i in range(len(NENGO_MASTER) ):
        list.append(unicode((NENGO_MASTER[i][0] + "：%5s") % year_list[i], "UTF-8"))
    # return (unicode list)
    return list


def selected():
    global LISTBOX, NENGO_MASTER
    cur_pos = LISTBOX.current()
    # 年号数字入力
    msg = unicode("入力 "+NENGO_MASTER[cur_pos][0] + "：", "UTF-8")
    if cur_pos == 0: # 西暦の欄
        e_year = int(time.strftime("%Y", time.localtime()))
        input_data = appuifw.query(msg,'number', e_year)
    else: # 元号の欄
        input_data = appuifw.query(msg,'number',1)
    if input_data == None: # canceled
        return
    # 入力チェック
    check, lower, upper = check_input(input_data, cur_pos) 
    if check == False: # input error
        globalui.global_note(unicode('数字が範囲外です\n%s -- %s' %
                (str(lower), str(upper)),'utf-8'),'info')
        return

    # 入力から西暦年作成
    e_year = NENGO_MASTER[cur_pos][1] + input_data - 1

    # 西暦年に対応する各元号の年を作成(return はunicodeのリスト)
    list = make_list(e_year)

    # 画面表示
    set_screen(list, cur_pos)


def set_screen(list, pos):
    global LISTBOX
    LISTBOX.set_list(list, pos)
    e32.ao_yield() # 画面反映


def set_menu():
    appuifw.app.menu = [(unicode("情報","utf-8"), about),
                        (unicode("終了","utf-8"), appExit) ]
    appuifw.app.exit_key_handler = lambda:appExit() #lock.signal()#do_dummy()


def about():
    msg = "App: " + __script__ + "\n" + "Version: " + __version__ + "\n" + \
           __copy__ + "\n" + __web__
    appuifw.query(unicode(msg, "UTF-8"), "query")


def do_dummy():
  pass


# アプリ終了
def appExit():
    lock.signal()


def main():
    global LISTBOX, NENGO_MASTER

    # 今年の西暦に対応する各年号を作成(return はunicodeのリスト)
    e_year = int(time.strftime("%Y", time.localtime()))
    list = make_list(e_year) # return is unicode list
    # 表示
    LISTBOX = appuifw.Listbox(list, selected)
    appuifw.app.body = LISTBOX
    appuifw.app.title = unicode(__script__ , "utf-8")
    e32.ao_yield() # 画面反映
    set_menu()
    lock.wait()


if __name__ == '__main__':
    main()
#    sys.exit()

# EOF #

